# Content

This archive contains the supplementary material used to conduct the security analyses of the 7 protocols occurring in Table 1:  
- `belenios_counter_last/`  
- `belenios_hash_last/`  
- `belenios_last/`  
- `belenios_tally/`  
- `chvote/`  
- `helios-toy-tally`  
- `swiss-post/`  

In addition, few variants of the Helios toy protocol are provided in `other/` to ease the understanding of the framework:  
- `helios-toy-onevote/`: voters verify during the voting phase but revote is not permitted. Verifiability holds.  
- `helios-toy-last/`: voters verify during the voting phase and revote is allowed. Verifiability fails.

# Analyses

For each protocol, a Makefile contains the necessary commands to complete the analysis of the protocol.  
Commands have the following form:  
`
proverif   
  -lib ../gsverif_library.pvl  
  -lib ../voting_framework.pvl
  -lib ../properties.pvl
  -lib protocol.pvl
  query.pv
`
where:  
- `gsverif_library.pvl` is the library containing the GSVerif events and axioms;   
- `voting_framework.pvl` is the library containing the generic processes of the framework;   
- `properties.pvl` is the library containg the generic lemmas presented in Section 5.2.2 to help proverif prove;   
- `protocol.pv` is the library containing the description of the protocol under study, i.e. the specific processes and macros of the framework; and  
- `query.pv` is the ProVerif file containing the query to prove.   

Note that different ProVerif runs are often needed to prove the intermediate lemmas because each proof requires specific ProVerif options.

# Timings

In the provided case studies, ProVerif always terminates in minutes.
However, the timings presented in Table 1 of the submitted paper correspond
to the verification time of the main queries.
ProVerif may take more time (up to 10min) to prove sub-properties, in particular the sanity checks.

# ProVerif

The security analyses have been conducted using the development branch `improved_scope_lemma` (commit d9117809) of the git repository of the tool ProVerif: [proverif git](https://gitlab.inria.fr/bblanche/proverif/-/tree/improved_scope_lemma)

Instructions to install ProVerif are available in the user manual: [user manual](https://bblanche.gitlabpages.inria.fr/proverif/manual.pdf)
